Content Security Policy (CSP) support

The Web Widget supports websites that use a Content Security Policy (CSP) and follows Google's strict CSP guidelines. We recommend following Google's policy for the best support and easiest setup with the Web Widget.

When following these guidelines, add the nonce attribute to the Web Widget snippet.

<!-- Start of Zendesk Widget script --><script  nonce="{random}"  id="ze-snippet"  src="https://static.zdassets.com/ekr/snippet.js?key=xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx"></script><!-- End of Zendesk Widget script -->

This {random} value must be a unique cryptographic number that is generated by the server each time the CSP is transmitted.

Note: This security policy works with the new version of the Zendesk Web Widget snippet. Please ensure that your snippet looks like the example above.

Custom setup (using other CSP directives)

We cannot guarantee that the Web Widget won't violate a custom CSP that does not follow Google's guidelines. However, if you add the following directives, it should prevent the Web Widget causing violations:

default-src 'self'            https://static.zdassets.com            https://ekr.zdassets.com            https://{zendeskSubdomain}.zendesk.com            https://*.zopim.com            wss://{zendeskSubdomain}.zendesk.com            wss://*.zopim.com;style-src 'unsafe-inline';img-src 'self'        https://v2assets.zopim.io        https://static.zdassets.com        data:;

If you have custom directives specified such as script-src or connect-src, add the hosts specified in default-src above.